#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/fs.h>
#include <linux/buffer_head.h>
#include <linux/blkdev.h>
#include "myfs.h"
int myfs_permission(struct inode *inode, int mask);
int myfs_readdir(struct file* filp, void* dirent,filldir_t filldir);

struct file_operations myfs_file_ops = {
	//.llseek = generic_file_llseek,
	.open = generic_file_open ,
	.read = do_sync_read,
	.write = do_sync_write,
	.aio_read = generic_file_aio_read,
	.aio_write = generic_file_aio_write,
};
 
struct file_operations myfs_dir_ops = {
		.llseek = generic_file_llseek,
		.read =  generic_read_dir,
		.readdir = myfs_readdir,

};

int myfs_readdir(struct file* filp, void* dirent,filldir_t filldir)
{
 	unsigned32 pos = filp->f_pos;
	struct inode *inode = filp->f_dentry->d_inode;
	struct super_block *sb = inode->i_sb;
	struct buffer_head *bh;
	struct myfs_dir_entry *dir_entry;
	struct myfs_inode *mi = (struct myfs_inode*)inode->i_private; 
	
	//printk(KERN_ALERT"MYFS: readdir is entering");	

	if(pos > (inode->i_size - sizeof(struct myfs_dir_entry)))
	return 0;	
	//printk(KERN_ALERT"position is correct");	


	if(!(bh = sb_bread(sb,mi->block_no)))
	{
		printk(KERN_ALERT"MYFS: block number  could not be read from disk");
		return -1;
	}	
	
again:
	pos = filp->f_pos;
	dir_entry=(struct myfs_dir_entry*)(bh->b_data+pos);	
	if(dir_entry->ino <= 0){
	  //printk(KERN_ALERT"inode number <=0 %d",dir_entry->ino);	
	  filp->f_pos = filp->f_pos + sizeof(struct myfs_dir_entry);
	  if(filp->f_pos <= ((inode->i_size) -sizeof(struct myfs_dir_entry))){	
		  goto again;	
		}
	}
	else{
		printk(KERN_ALERT"called filldir dirent with obtained inode number %d name %s ", dir_entry->ino, dir_entry->name);
 	 	filldir(dirent,dir_entry->name,MAX_NAME_LEN,pos,dir_entry->ino,DT_UNKNOWN);
	  filp->f_pos = filp->f_pos + sizeof(struct myfs_dir_entry);
	}
	brelse(bh);
	printk(KERN_ALERT"MYFS: readdir is returning");	
	return 1;

		
}//function

