//#include "io.h"

//#define MYFS_MAGIC_STR	"MyFs V 1.1" /*its a string value*/
#define MYFS_SUPER_MAGIC 0xdeadbeef /*its a hex value*/
#define MAX_NAME_LEN 25
#define MYFS_SUPER_BLOCK  0
#define MYFS_INODE_BLOCK 1 /*inode info stored after super block*/
#define MYFS_ROOT_BLOCK 2 /*inode info stored after super block*/
#define MYFS_ROOT_INO 1 /* From Here root inode is number = 1 earlier it was 2 */
#define MYFS_CLEAN 0 
#define MYFS_DIRTY ~(MYFS_CLEAN)


#define MYFS_FILE (S_IFREG|S_IRUSR|S_IWUSR|S_IXUSR|S_IROTH|S_IXOTH|S_IRGRP|S_IXGRP) /*NEW4*/
#define MYFS_DIR (S_IFDIR|S_IRUSR|S_IWUSR|S_IXUSR|S_IROTH|S_IXOTH|S_IRGRP|S_IXGRP) /*NEW4*/
#define S_TYPE(a,b) ((a) & (b) ) /*NEW4*/


#define MYFS_DEFAULT_BS	4096   /*No of inode that can be stored = blocksize/sizeof(myfs_inode)*/	
#define MAGIC_LEN 10

typedef unsigned int unsigned32;
typedef unsigned short unsigned16;


struct myfs_inode {
	unsigned16 ino;
	unsigned16 block_no;
	unsigned16 filetype;


	unsigned16 uid;
	unsigned16 gid;
	unsigned16 size;
	unsigned16 perm;
	
	struct timespec atime;
	struct timespec ctime;
	struct timespec mtime;

	unsigned32 magic;
	//unsigned16 mode;//TODO?? why this also removed ??
	//unsigned16 links; /*TODO?? why removed in version4*/
};


struct myfs_super_block {
/*its the disk super block it has to contain the inode bitmap
and block bitmap 
and a few basic information like blick size and number of blocks in filesystem 
*/
	unsigned32 s_magic;/*Super magic string deadbeef*/
	
	unsigned32 inode_bmp;/*restricts files to number 32*/
	unsigned32 block_bmp; 
	
	unsigned32 block_size;
	unsigned32 root_inode;

//	unsigned32 inodes_count;/*filesystem inode count*/
//	unsigned32 blocks_count;/*filesystem size in blocks allocated*/
	
	//unsigned16 free_count;
	//unsigned16 first_data_block;
	
	//uchar magic[MAGIC_LEN];
	unsigned32 total_inodes;//Filesystem size in blocks
	unsigned32 total_blocks;//Filesystem size in blocks
	unsigned32 free_blocks;//Filesystem size in blocks
  	unsigned16 first_data_block;

	unsigned32 dirty;
};


struct myfs_dir_entry {
	unsigned32 ino;//inode number 
	unsigned32 rec_len;
	unsigned32 name_len;
	char name[MAX_NAME_LEN];
};






